<script setup lang="ts">
import { onMounted } from 'vue'
import { nextTick, ref } from 'vue'

import type { StoreExp } from '@/types/StoreExpenses'
import { useStoreExp } from '@/stores/storeexpenses'
import type { VForm } from 'vuetify/components'
import { useDate } from 'vuetify'
import { useBranchStore } from '@/stores/branch'

const storeexps = ref<StoreExp[]>([])
const storeexpsStore = useStoreExp()
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Status',
    value: 'status',
    key: 'status'
  },
  {
    title: 'ElectricBill',
    value: 'electricBill',
    key: 'electricBill'
  },
  {
    title: 'WaterBill',
    value: 'waterBill',
    key: 'waterBill'
  },
  {
    title: 'Total',
    value: 'total',
    key: 'total'
  },
  {
    title: 'Due-Date',
    value: 'due_date',
    key: 'due_date'
  },
  {
    title: 'Branch',
    key: 'branch',
    value: (item: any | StoreExp) => item.branch.name
  },
  {
    title: 'Actions',
    key: 'actions',
    sortable: false
  }
]
const form = ref(false)
const loading = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
const refForm = ref<VForm | null>(null)
const usebranchStore = useBranchStore()
let editedIndex = -1
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    storeexpsStore.clearForm()
  })
}

async function deleteItemConfirm() {
  await storeexpsStore.deleteStoreExp()
  closeDelete()
}

async function editItem(item: StoreExp) {
  if (!item.id) return
  await storeexpsStore.getStoreExp(item.id)
  dialog.value = true
}

async function deleteItem(item: StoreExp) {
  if (!item.id) return
  await storeexpsStore.getStoreExp(item.id)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    storeexpsStore.clearForm()
  })
}

onMounted(async () => {
  await storeexpsStore.getStoreExps()
})

const search = ref('')

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await storeexpsStore.saveStoreExp()
  closeDialog()
}
</script>

<template>
  <div class="app-container">
    <v-data-table
      :headers="headers"
      :search="search"
      :items="storeexpsStore.StoreExps"
      class="custom-datatable"
    >
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(247, 156, 82)">
          <v-toolbar-title style="color: white">Expenses Report</v-toolbar-title>
          <v-spacer></v-spacer>

          <v-text-field
            rounded
            v-model="search"
            label="Search"
            prepend-inner-icon="mdi-magnify"
            variant="solo"
            hide-details
            single-line
          ></v-text-field>

          <v-btn icon="mdi-cached" color="text-black" @click="storeexpsStore.getStoreExps"></v-btn>
          <!-- <v-btn outlined color="white" @click="showItemsWithSameDate">Show Items with Same Date</v-btn> -->
          <v-divider class="mx-4" inset vertical></v-divider>

          <v-spacer></v-spacer>

          <v-dialog v-model="dialog" persistent max-width="500" content-class="center-dialog">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
              >
                New Report
              </v-btn>
            </template>
            <v-card style="width: 500px">
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col class="text-center" style="font-size: 17px" cols="12">D-Coffee</v-col>
                    </v-row>
                    <v-row>
                      <v-col class="text-center" style="font-size: 17px" cols="12"
                        >สรุปรายงานค่าใช้จ่าย</v-col
                      >
                    </v-row>
                    <v-row>
                      <v-col class="text-center" style="font-size: 17px" cols="12">วันที่ </v-col>
                    </v-row>
                    <v-row>
                      <v-col class="text-left" style="font-size: 17px" cols="12">สาขา</v-col>
                    </v-row>
                    <v-row>
                      <v-col class="text-left" style="font-size: 17px" cols="12">ค่าน้ำ</v-col>
                    </v-row>
                    <v-row>
                      <v-col class="text-left" style="font-size: 17px" cols="12">ค่าไฟ</v-col>
                    </v-row>
                    <v-row>
                      <v-col class="text-left" style="font-size: 17px" cols="12"
                        >พนักงานผู้รับผิดชอบ</v-col
                      >
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:no-data>
        <v-btn color="rgb(214, 175, 125)" @click="storeexpsStore.getStoreExps"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
